diff --git a/tests/test_flask_admin.py b/tests/test_flask_admin.py
index 45ebcc6..468d24d 100644
--- a/tests/test_flask_admin.py
+++ b/tests/test_flask_admin.py
@@ -852,15 +878,16 @@ class FlaskAdmintests(ModelFlasktests):
                 output = self.app.post(
                     '/admin/test_election/candidates/new/multi', data=data)
                 self.assertEqual(output.status_code, 200)
-                self.assertTrue('Add candidates' in output.data)
+                output_text = output.get_data(as_text=True)
+                self.assertTrue('Add candidates' in output_text)
                 if self.get_wtforms_version() >= (2, 2):
                     self.assertIn(
                         'input class="form-control" id="candidate" '
-                        'name="candidate" required type="text"', output.data)
+                        'name="candidate" required type="text"', output_text)
                 else:
                     self.assertIn(
                         'input class="form-control" id="candidate" '
-                        'name="candidate" type="text"', output.data)
+                        'name="candidate" type="text"', output_text)
 
                 csrf_token = self.get_csrf(output=output)
 
@@ -872,18 +899,19 @@ class FlaskAdmintests(ModelFlasktests):
                 output = self.app.post(
                     '/admin/test_election/candidates/new/multi', data=data)
                 self.assertEqual(output.status_code, 200)
-                self.assertTrue('Add candidates' in output.data)
+                output_text = output.get_data(as_text=True)
+                self.assertTrue('Add candidates' in output_text)
                 if self.get_wtforms_version() >= (2, 2):
                     self.assertIn(
                         'input class="form-control" id="candidate" '
-                        'name="candidate" required type="text"', output.data)
+                        'name="candidate" required type="text"', output_text)
                 else:
                     self.assertIn(
                         'input class="form-control" id="candidate" '
-                        'name="candidate" type="text"', output.data)
+                        'name="candidate" type="text"', output_text)
                 self.assertTrue(
                     '<div class="form-control-feedback">This field is required.</div>'
-                    in output.data)
+                    in output_text)
 
                 data = {
                     'candidate': 'pingou|patrick!https://fedoraproject.org|'
@@ -895,10 +923,11 @@ class FlaskAdmintests(ModelFlasktests):
                     '/admin/test_election/candidates/new/multi', data=data,
                     follow_redirects=True)
                 self.assertEqual(output.status_code, 200)
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
                     'Added 3 candidates'
-                    in output.data)
-                self.assertTrue('Candidates <span class="label label-pill label-default">6</span>' in output.data)
+                    in output_text)
+                self.assertTrue('Candidates <span class="label label-pill label-default">6</span>' in output_text)
 
     def test_admin_edit_candidate(self):
         """ Test the admin_edit_candidate function. """
@@ -926,31 +955,32 @@ class FlaskAdmintests(ModelFlasktests):
 
                 output = self.app.get('/admin/test_election/candidates/1/edit')
                 self.assertEqual(output.status_code, 200)
+                output_text = output.get_data(as_text=True)
 
-                self.assertTrue('Edit candidate' in output.data)
+                self.assertTrue('Edit candidate' in output_text)
                 if self.get_wtforms_version() >= (2, 2):
                     self.assertIn(
                         'input class="form-control" id="name" name="name" '
-                        'required type="text"', output.data)
+                        'required type="text"', output_text)
                 else:
                     self.assertIn(
                         'input class="form-control" id="name" name="name" '
-                        'type="text"', output.data)
+                        'type="text"', output_text)
 
                 data = {
                     'name': 'Toshio Kuratomi',
                     'url': 'https://fedoraproject.org/wiki/User:Toshio',
                 }
 
-                self.assertTrue('Edit candidate' in output.data)
+                self.assertTrue('Edit candidate' in output_text)
                 if self.get_wtforms_version() >= (2, 2):
                     self.assertIn(
                         'input class="form-control" id="name" name="name" '
-                        'required type="text"', output.data)
+                        'required type="text"', output_text)
                 else:
                     self.assertIn(
                         'input class="form-control" id="name" name="name" '
-                        'type="text"', output.data)
+                        'type="text"', output_text)
 
                 csrf_token = self.get_csrf(output=output)
 
@@ -962,34 +992,36 @@ class FlaskAdmintests(ModelFlasktests):
                 output = self.app.post(
                     '/admin/test_election/candidates/1/edit', data=data)
                 self.assertEqual(output.status_code, 200)
-                self.assertTrue('Edit candidate' in output.data)
+                output_text = output.get_data(as_text=True)
+                self.assertTrue('Edit candidate' in output_text)
                 if self.get_wtforms_version() >= (2, 2):
                     self.assertIn(
                         'input class="form-control" id="name" name="name" '
-                        'required type="text"', output.data)
+                        'required type="text"', output_text)
                 else:
                     self.assertIn(
                         'input class="form-control" id="name" name="name" '
-                        'type="text"', output.data)
+                        'type="text"', output_text)
                 self.assertTrue(
                     '<div class="form-control-feedback">This field is required.</div>'
-                    in output.data)
+                    in output_text)
 
                 # Check election before edit
                 output = self.app.get('/admin/test_election/')
                 self.assertEqual(output.status_code, 200)
-                self.assertTrue('Candidates <span class="label label-pill label-default">3</span>' in output.data)
+                output_text = output.get_data(as_text=True)
+                self.assertTrue('Candidates <span class="label label-pill label-default">3</span>' in output_text)
                 if self.get_wtforms_version() >= (2, 2):
                     self.assertIn(
                         'input class="form-control" id="seats_elected" '
                         'name="seats_elected" required type="text" value="1"',
-                        output.data)
+                        output_text)
                 else:
                     self.assertIn(
                         'input class="form-control" id="seats_elected" '
                         'name="seats_elected" type="text" value="1"',
-                        output.data)
-                self.assertTrue('<div class="list-group-item">Toshio' in output.data)
+                        output_text)
+                self.assertTrue('<div class="list-group-item">Toshio' in output_text)
 
                 data = {
                     'name': 'Toshio Kuratomi',
@@ -1001,11 +1033,12 @@ class FlaskAdmintests(ModelFlasktests):
                     '/admin/test_election/candidates/1/edit', data=data,
                     follow_redirects=True)
                 self.assertEqual(output.status_code, 200)
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
                     'Candidate "Toshio Kuratomi" saved'
-                    in output.data)
-                self.assertTrue('Candidates <span class="label label-pill label-default">3</span>' in output.data)
-                self.assertTrue('<div class="list-group-item">Toshio' in output.data)
+                    in output_text)
+                self.assertTrue('Candidates <span class="label label-pill label-default">3</span>' in output_text)
+                self.assertTrue('<div class="list-group-item">Toshio' in output_text)
 
     def test_admin_delete_candidate(self):
         """ Test the admin_delete_candidate function. """
@@ -1033,18 +1066,20 @@ class FlaskAdmintests(ModelFlasktests):
 
                 output = self.app.get('/admin/test_election/candidates/1/delete')
                 self.assertEqual(output.status_code, 200)
+                output_text = output.get_data(as_text=True)
 
-                self.assertTrue('<h2>Delete candidate</h2>' in output.data)
+                self.assertTrue('<h2>Delete candidate</h2>' in output_text)
                 self.assertTrue(
                     'p>Are you sure you want to delete candidate "Toshio"?</p'
-                    in output.data)
+                    in output_text)
 
                 output = self.app.post('/admin/test_election/candidates/1/delete')
                 self.assertEqual(output.status_code, 200)
-                self.assertTrue('<h2>Delete candidate</h2>' in output.data)
+                output_text = output.get_data(as_text=True)
+                self.assertTrue('<h2>Delete candidate</h2>' in output_text)
                 self.assertTrue(
                     'p>Are you sure you want to delete candidate "Toshio"?</p'
-                    in output.data)
+                    in output_text)
 
                 csrf_token = self.get_csrf(output=output)
 
@@ -1057,27 +1092,29 @@ class FlaskAdmintests(ModelFlasktests):
                     '/admin/test_election/candidates/1/delete', data=data,
                     follow_redirects=True)
                 self.assertEqual(output.status_code, 200)
-                self.assertTrue('<h2>test election shortdesc</h2>' in output.data)
+                output_text = output.get_data(as_text=True)
+                self.assertTrue('<h2>test election shortdesc</h2>' in output_text)
                 self.assertTrue(
                     'Could not delete this candidate. Is it '
-                    'already part of an election?' in output.data)
+                    'already part of an election?' in output_text)
 
                 # Check election before edit
                 output = self.app.get('/admin/test_election4/')
-                self.assertTrue('Candidates <span class="label label-pill label-default">2</span>' in output.data)
+                output_text = output.get_data(as_text=True)
+                self.assertTrue('Candidates <span class="label label-pill label-default">2</span>' in output_text)
                 if self.get_wtforms_version() >= (2, 2):
                     self.assertIn(
                         'input class="form-control" id="seats_elected" '
                         'name="seats_elected" required type="text" value="1"',
-                        output.data)
+                        output_text)
                 else:
                     self.assertIn(
                         'input class="form-control" id="seats_elected" '
                         'name="seats_elected" type="text" value="1"',
-                        output.data)
-                self.assertTrue('<div class="list-group-item">Toshio' in output.data)
+                        output_text)
+                self.assertTrue('<div class="list-group-item">Toshio' in output_text)
                 self.assertTrue(
-                    'value="test election 4 shortdesc">' in output.data)
+                    'value="test election 4 shortdesc">' in output_text)
 
                 # Delete one candidate
                 data = {
@@ -1088,13 +1125,14 @@ class FlaskAdmintests(ModelFlasktests):
                     '/admin/test_election4/candidates/10/delete', data=data,
                     follow_redirects=True)
                 self.assertEqual(output.status_code, 200)
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
                     'Candidate "Toshio" deleted'
-                    in output.data)
+                    in output_text)
                 self.assertTrue(
-                    'value="test election 4 shortdesc">' in output.data)
-                self.assertTrue('Candidates <span class="label label-pill label-default">1</span>' in output.data)
-                self.assertFalse('<div class="list-group-item">Toshio' in output.data)
+                    'value="test election 4 shortdesc">' in output_text)
+                self.assertTrue('Candidates <span class="label label-pill label-default">1</span>' in output_text)
+                self.assertFalse('<div class="list-group-item">Toshio' in output_text)
 
 
 if __name__ == '__main__':
diff --git a/tests/test_flask_elections.py b/tests/test_flask_elections.py
index 5400851..09e99cc 100644
--- a/tests/test_flask_elections.py
+++ b/tests/test_flask_elections.py
@@ -49,9 +49,10 @@ class FlaskElectionstests(ModelFlasktests):
         """ Test the vote function without data. """
         output = self.app.get('/vote/test_election')
         self.assertEqual(output.status_code, 302)
+        output_text = output.get_data(as_text=True)
         self.assertIn(
             '/login?next=http%3A%2F%2Flocalhost%2Fvote%2Ftest_election',
-            output.data)
+            output_text)
 
         user = FakeUser(['packager'], username='pingou')
         with user_set(fedora_elections.APP, user, oidc_id_token='foobar'):
@@ -62,17 +63,19 @@ class FlaskElectionstests(ModelFlasktests):
                 self.assertEqual(output.status_code, 302)
 
                 output = self.app.get('/vote/test_election', follow_redirects=True)
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
                     'The election, test_election, does not exist.'
-                    in output.data)
+                    in output_text)
 
     def test_vote(self):
         """ Test the vote function. """
         output = self.app.get('/vote/test_election')
         self.assertEqual(output.status_code, 302)
+        output_text = output.get_data(as_text=True)
         self.assertIn(
             '/login?next=http%3A%2F%2Flocalhost%2Fvote%2Ftest_election',
-            output.data)
+            output_text)
 
         self.setup_db()
 
@@ -84,9 +87,10 @@ class FlaskElectionstests(ModelFlasktests):
 
             output = self.app.get(
                 '/vote/test_election', follow_redirects=True)
+            output_text = output.get_data(as_text=True)
             self.assertTrue(
                 'You must sign the CLA to vote'
-                in output.data)
+                in output_text)
 
         user = FakeUser([], username='pingou')
         with user_set(fedora_elections.APP, user, oidc_id_token='foobar'):
@@ -99,9 +103,10 @@ class FlaskElectionstests(ModelFlasktests):
 
                 output = self.app.get(
                     '/vote/test_election', follow_redirects=True)
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
                     'You need to be in one another group than '
-                    'CLA to vote' in output.data)
+                    'CLA to vote' in output_text)
 
         user = FakeUser(['packager'], username='pingou')
         with user_set(fedora_elections.APP, user, oidc_id_token='foobar'):
@@ -115,9 +120,10 @@ class FlaskElectionstests(ModelFlasktests):
                 # Election closed and results open
                 output = self.app.get(
                     '/vote/test_election3', follow_redirects=True)
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
                     'You are not among the groups that are '
-                    'allowed to vote for this election' in output.data)
+                    'allowed to vote for this election' in output_text)
 
         user = FakeUser(['voters'], username='pingou')
         with user_set(fedora_elections.APP, user, oidc_id_token='foobar'):
@@ -131,75 +137,84 @@ class FlaskElectionstests(ModelFlasktests):
                 # Election closed and results open
                 output = self.app.get(
                     '/vote/test_election', follow_redirects=True)
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
                     '<span class="label label-danger">Election Closed</span>'
-                    in output.data)
+                    in output_text)
 
                 # Election closed and results are embargoed
                 output = self.app.get(
                     '/vote/test_election2', follow_redirects=True)
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
                     '<span class="label label-danger">Election Closed</span>'
-                    in output.data)
+                    in output_text)
 
                 # Election still pending
                 output = self.app.get(
                     '/vote/test_election4', follow_redirects=True)
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
                     'Voting has not yet started, sorry.'
-                    in output.data)
+                    in output_text)
 
                 # Election in progress
                 output = self.app.get('/vote/test_election3')
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
-                    'test election 3 shortdesc' in output.data)
+                    'test election 3 shortdesc' in output_text)
                 self.assertTrue(
                     '<input type="hidden" name="action" value="preview" />'
-                    in output.data)
+                    in output_text)
 
                 # Election in progress
                 output = self.app.get('/vote/test_election5')
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
-                    'test election 5 shortdesc' in output.data)
+                    'test election 5 shortdesc' in output_text)
                 self.assertTrue(
                     '<input type="hidden" name="action" value="preview" />'
-                    in output.data)
+                    in output_text)
 
     def test_election_results(self):
         """ Test the election_results function - the preview part. """
         output = self.app.get(
             '/about/test_election', follow_redirects=True)
         self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
         self.assertTrue(
             'The election, test_election,  does not exist.'
-            in output.data)
+            in output_text)
 
         self.setup_db()
 
         output = self.app.get('/about/test_election')
         self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
         self.assertTrue(
             '<th class="nowrap" title="Number of votes received">Votes</th>'
-            in output.data)
+            in output_text)
         self.assertTrue(
             '<h3>Some statistics about this election</h3>'
-            in output.data)
+            in output_text)
 
         output = self.app.get(
             '/about/test_election2', follow_redirects=True)
         self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
         self.assertTrue(
             'The results for this election cannot be viewed because they are '
-            in output.data)
+            in output_text)
 
         user = FakeUser(['packager'], username='toshio')
         with user_set(fedora_elections.APP, user):
             output = self.app.get(
                 '/about/test_election2', follow_redirects=True)
             self.assertEqual(output.status_code, 200)
+            output_text = output.get_data(as_text=True)
             self.assertTrue(
                 'The results for this election cannot be viewed because they are '
-                in output.data)
+                in output_text)
 
         user = FakeUser(
             fedora_elections.APP.config['FEDORA_ELECTIONS_ADMIN_GROUP'],
@@ -211,55 +226,60 @@ class FlaskElectionstests(ModelFlasktests):
                 output = self.app.get(
                     '/about/test_election2', follow_redirects=True)
                 self.assertEqual(output.status_code, 200)
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
                     'You are only seeing these results because you are an admin.'
-                    in output.data)
+                    in output_text)
                 self.assertTrue(
                     'The results for this election are currently embargoed '
-                    in output.data)
+                    in output_text)
                 self.assertTrue(
                     '<th class="nowrap" title="Number of votes received">Votes</th>'
-                    in output.data)
+                    in output_text)
                 self.assertTrue(
                     '<h3>Some statistics about this election</h3>'
-                    in output.data)
+                    in output_text)
 
         user = FakeUser(['gitr2spec'], username='kevin')
         with user_set(fedora_elections.APP, user):
             output = self.app.get(
                 '/about/test_election3', follow_redirects=True)
             self.assertEqual(output.status_code, 200)
+            output_text = output.get_data(as_text=True)
             self.assertTrue(
                 '<span class="label label-success">Election Open</span>'
-                 in output.data)
+                 in output_text)
 
     def test_election_results_text(self):
         """ Test the election_results_text function - the preview part. """
         output = self.app.get(
             '/results/test_election/text', follow_redirects=True)
         self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
         self.assertTrue(
             'The election, test_election, does not exist.'
-            in output.data)
+            in output_text)
 
         self.setup_db()
 
         output = self.app.get(
             '/results/test_election/text', follow_redirects=True)
         self.assertEqual(output.status_code, 200)
+        output_text = output.get_data(as_text=True)
         self.assertTrue(
             'The text results are only available to the '
-            'admins' in output.data)
+            'admins' in output_text)
 
         user = FakeUser(['packager'], username='toshio')
         with user_set(fedora_elections.APP, user):
             output = self.app.get(
                 '/results/test_election2/text', follow_redirects=True)
             self.assertEqual(output.status_code, 200)
+            output_text = output.get_data(as_text=True)
             self.assertTrue(
                 'The text results are only available to the '
-                'admins' in output.data)
-            self.assertTrue('<h2>Elections' in output.data)
+                'admins' in output_text)
+            self.assertTrue('<h2>Elections' in output_text)
 
         user = FakeUser(
             fedora_elections.APP.config['FEDORA_ELECTIONS_ADMIN_GROUP'],
@@ -271,6 +291,7 @@ class FlaskElectionstests(ModelFlasktests):
                 output = self.app.get(
                     '/results/test_election/text', follow_redirects=True)
                 self.assertEqual(output.status_code, 200)
+                output_text = output.get_data(as_text=True)
                 exp = """<!DOCTYPE html>
 
 <html xmlns="http://www.w3.org/1999/xhtml">
@@ -307,12 +328,13 @@ candidates for running this elections!
 
 </body>
 </html>"""
-                print(output.data)
-                self.assertEqual(output.data, exp)
+                print(output_text)
+                self.assertEqual(output_text, exp)
 
                 output = self.app.get(
                     '/results/test_election2/text', follow_redirects=True)
                 self.assertEqual(output.status_code, 200)
+                output_text = output.get_data(as_text=True)
                 exp = """<!DOCTYPE html>
 
 <html xmlns="http://www.w3.org/1999/xhtml">
@@ -346,17 +368,18 @@ candidates for running this elections!
 </body>
 </html>"""
 
-                self.assertEqual(output.data, exp)
+                self.assertEqual(output_text, exp)
 
         user = FakeUser(['gitr2spec'], username='kevin')
         with user_set(fedora_elections.APP, user):
             output = self.app.get(
                 '/results/test_election3/text', follow_redirects=True)
             self.assertEqual(output.status_code, 200)
+            output_text = output.get_data(as_text=True)
             self.assertTrue(
                 'Sorry but this election is in progress,'
-                ' and you may not see its results yet.' in output.data)
-            self.assertTrue('Open elections' in output.data)
+                ' and you may not see its results yet.' in output_text)
+            self.assertTrue('Open elections' in output_text)
 
 
 if __name__ == '__main__':
diff --git a/tests/test_flask_irc.py b/tests/test_flask_irc.py
index 59fed2a..628ace6 100644
--- a/tests/test_flask_irc.py
+++ b/tests/test_flask_irc.py
@@ -49,9 +49,10 @@ class FlaskIrcElectionstests(ModelFlasktests):
         """ Test the vote_irc function - the preview part. """
         output = self.app.get('/vote/test_election')
         self.assertEqual(output.status_code, 302)
+        output_text = output.get_data(as_text=True)
         self.assertIn(
             '/login?next=http%3A%2F%2Flocalhost%2Fvote%2Ftest_election',
-            output.data)
+            output_text)
 
         self.setup_db()
 
@@ -60,15 +61,15 @@ class FlaskIrcElectionstests(ModelFlasktests):
             with patch(
                     'fedora_elections.OIDC.user_getfield',
                     MagicMock(return_value=['packager'])):
-                output = self.app.get(
-                    '/vote/test_election7')
+                output = self.app.get('/vote/test_election7')
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
-                    'test election 7 shortdesc' in output.data)
+                    'test election 7 shortdesc' in output_text)
                 self.assertTrue(
                     '<input type="hidden" name="action" value="preview" />'
-                    in output.data)
+                    in output_text)
 
-                csrf_token = output.data.split(
+                csrf_token = output_text.split(
                     'name="csrf_token" type="hidden" value="')[1].split('">')[0]
 
                 # Invalid vote: No candidate
@@ -78,8 +79,9 @@ class FlaskIrcElectionstests(ModelFlasktests):
 
                 output = self.app.post('/vote/test_election7', data=data)
                 self.assertEqual(output.status_code, 200)
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
-                    'test election 7 shortdesc' in output.data)
+                    'test election 7 shortdesc' in output_text)
 
                 # Valid input
                 data = {
@@ -91,22 +93,24 @@ class FlaskIrcElectionstests(ModelFlasktests):
 
                 output = self.app.post('/vote/test_election7', data=data)
                 self.assertEqual(output.status_code, 200)
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
-                    'test election 7 shortdesc' in output.data)
+                    'test election 7 shortdesc' in output_text)
                 self.assertTrue(
                     '<input type="hidden" name="action" value="submit" />'
-                    in output.data)
+                    in output_text)
                 self.assertTrue(
                     'Please confirm your vote!'
-                    in output.data)
+                    in output_text)
 
     def test_vote_irc_process(self):
         """ Test the vote_irc function - the voting part. """
         output = self.app.get('/vote/test_election')
         self.assertEqual(output.status_code, 302)
+        output_text = output.get_data(as_text=True)
         self.assertIn(
             '/login?next=http%3A%2F%2Flocalhost%2Fvote%2Ftest_election',
-            output.data)
+            output_text)
 
         self.setup_db()
 
@@ -125,8 +129,9 @@ class FlaskIrcElectionstests(ModelFlasktests):
                     '/vote/test_election7', data=data,
                     follow_redirects=True)
                 self.assertEqual(output.status_code, 200)
+                output_text = output.get_data(as_text=True)
 
-                csrf_token = output.data.split(
+                csrf_token = output_text.split(
                     'name="csrf_token" type="hidden" value="')[1].split('">')[0]
 
                 # Valid input
@@ -141,10 +146,11 @@ class FlaskIrcElectionstests(ModelFlasktests):
                     '/vote/test_election7', data=data,
                     follow_redirects=True)
                 self.assertEqual(output.status_code, 200)
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
                     'Your vote has been recorded.  Thank you!'
-                    in output.data)
-                self.assertTrue('Open elections' in output.data)
+                    in output_text)
+                self.assertTrue('Open elections' in output_text)
 
     def test_vote_irc_revote(self):
         """ Test the vote_irc function - the re-voting part. """
@@ -157,7 +163,8 @@ class FlaskIrcElectionstests(ModelFlasktests):
                     'fedora_elections.OIDC.user_getfield',
                     MagicMock(return_value=['packager'])):
                 retrieve_csrf = self.app.post('/vote/test_election7')
-                csrf_token = retrieve_csrf.data.split(
+                output_text = retrieve_csrf.get_data(as_text=True)
+                csrf_token = output_text.split(
                     'name="csrf_token" type="hidden" value="')[1].split('">')[0]
                 # Valid input
                 data = {
@@ -184,10 +191,11 @@ class FlaskIrcElectionstests(ModelFlasktests):
                 output = self.app.post('/vote/test_election7', data=newdata, follow_redirects=True)
             #Next, we need to check if the vote has been recorded
                 self.assertEqual(output.status_code, 200)
+                output_text = output.get_data(as_text=True)
                 self.assertTrue(
                     'Your vote has been recorded.  Thank you!'
-                    in output.data)
-                self.assertTrue('Open elections' in output.data)
+                    in output_text)
+                self.assertTrue('Open elections' in output_text)
                 vote = fedora_elections.models.Vote
                 votes = vote.of_user_on_election(self.session, "nerdsville", '7')
                 self.assertEqual(votes[0].value, -1)
@@ -195,6 +203,7 @@ class FlaskIrcElectionstests(ModelFlasktests):
 
             #If we haven't failed yet, HOORAY!
 
+
 if __name__ == '__main__':
     SUITE = unittest.TestLoader().loadTestsFromTestCase(FlaskIrcElectionstests)
     unittest.TextTestRunner(verbosity=2).run(SUITE)
